org.springframework.batch.item.database.support

## Class PostgresPagingQueryProvider

- java.lang.Object
- - org.springframework.batch.item.database.support.AbstractSqlPagingQueryProvider
  - - org.springframework.batch.item.database.support.PostgresPagingQueryProvider

- All Implemented Interfaces:
    PagingQueryProvider

      public class PostgresPagingQueryProvider
      extends AbstractSqlPagingQueryProvider

  Postgres implementation of a `PagingQueryProvider` using database specific features. When using the groupClause, this implementation expects all select fields not used in aggregate functions to be included in the groupClause (the provider does not add them for you).
  Since:
    2.0
  Author:
    Thomas Risberg, Michael Minella

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PostgresPagingQueryProvider()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `generateFirstPageQuery(int pageSize)` Method generating the query string to be used for retrieving the first page.
    `java.lang.String` | `generateJumpToItemQuery(int itemIndex, int pageSize)` Method generating the query string to be used for jumping to a specific item position.
    `java.lang.String` | `generateRemainingPagesQuery(int pageSize)` Method generating the query string to be used for retrieving the pages following the first page.

    - ### Methods inherited from class org.springframework.batch.item.database.support.AbstractSqlPagingQueryProvider

      `getFromClause, getGroupClause, getParameterCount, getSelectClause, getSortKeyPlaceHolder, getSortKeys, getSortKeysWithoutAliases, getWhereClause, init, isUsingNamedParameters, setFromClause, setGroupClause, setSelectClause, setSortKeys, setWhereClause`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PostgresPagingQueryProvider

          public PostgresPagingQueryProvider()

  - ### Method Detail

    - #### generateFirstPageQuery

          public java.lang.String generateFirstPageQuery(int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for retrieving the first page. This method must be implemented in sub classes.
      Specified by:
        `generateFirstPageQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateFirstPageQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `pageSize` - number of rows to read per page
      Returns:
        query string

    - #### generateRemainingPagesQuery

          public java.lang.String generateRemainingPagesQuery(int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for retrieving the pages following the first page. This method must be implemented in sub classes.
      Specified by:
        `generateRemainingPagesQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateRemainingPagesQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `pageSize` - number of rows to read per page
      Returns:
        query string

    - #### generateJumpToItemQuery

          public java.lang.String generateJumpToItemQuery(int itemIndex,
                                                          int pageSize)

      Description copied from class: `AbstractSqlPagingQueryProvider`
      Method generating the query string to be used for jumping to a specific item position. This method must be implemented in sub classes.
      Specified by:
        `generateJumpToItemQuery` in interface `PagingQueryProvider`
      Specified by:
        `generateJumpToItemQuery` in class `AbstractSqlPagingQueryProvider`
      Parameters:
        `itemIndex` - the index of the item to jump to
        `pageSize` - number of rows to read per page
      Returns:
        query string